Unit processservice;

{$MODE ObjFPC}
{$H+}

interface

uses fprpcclient;

Type
  
  { --------------------------------------------------------------------
    TprocesscontrolService
    --------------------------------------------------------------------}
  
  TprocesscontrolService = Class(TRPCCustomService)
  Protected
    Function RPCClassName : string; override;
  Public
    Function GetStatus (processID : String; offset : NativeInt; aOnSuccess : TJSValueResultHandler = Nil; aOnFailure : TRPCFailureCallBack = Nil) : NativeInt;
    Function StartProcess (a : String; b : String; aOnSuccess : TJSValueResultHandler = Nil; aOnFailure : TRPCFailureCallBack = Nil) : NativeInt;
  end;
  
  implementation
  
  
  { --------------------------------------------------------------------
    TprocesscontrolService
    --------------------------------------------------------------------}
  
  
  Function TprocesscontrolService.RPCClassName : string;
  
  begin
    Result:='processcontrol';
  end;
  
  
  Function TprocesscontrolService.GetStatus (processID : String; offset : NativeInt; aOnSuccess : TJSValueResultHandler = Nil; aOnFailure : TRPCFailureCallBack = Nil) : NativeInt;
  
    Procedure DoSuccess(Sender : TObject; const aResult : JSValue);
    
    begin
      If Assigned(aOnSuccess) then
        aOnSuccess((aResult))
    end;
  
  Var
    _Params : JSValue;
  
  begin
    StartParams;
    AddParam('processID',processID);
    AddParam('offset',offset);
    _Params:=EndParams;
    Result:=ExecuteRequest(RPCClassName,'GetStatus',_Params,@DoSuccess,aOnFailure);
  end;
  
  
  Function TprocesscontrolService.StartProcess (a : String; b : String; aOnSuccess : TJSValueResultHandler = Nil; aOnFailure : TRPCFailureCallBack = Nil) : NativeInt;
  
    Procedure DoSuccess(Sender : TObject; const aResult : JSValue);
    
    begin
      If Assigned(aOnSuccess) then
        aOnSuccess((aResult))
    end;
  
  Var
    _Params : JSValue;
  
  begin
    StartParams;
    AddParam('a',a);
    AddParam('b',b);
    _Params:=EndParams;
    Result:=ExecuteRequest(RPCClassName,'StartProcess',_Params,@DoSuccess,aOnFailure);
  end;
  
  
  
  
  end.
