unit forms.index;

{$mode ObjFPC}

interface

uses
  SysUtils, Classes, Rtl.HTMLActions, htmlfragment, Web, fprpcclient, remoteexecutor;

type
  { TfrmIndex }

  TfrmIndex = class(THTMLFragment)
    actbtnCancel: THTMLElementAction;
    actbtnStart: THTMLElementAction;
    actedtA: THTMLElementAction;
    actedtB: THTMLElementAction;
    alForm: THTMLElementActionList;
    rpc: TPas2jsRPCClient;
    procedure actbtnCancelExecute(Sender: TObject; Event: TJSEvent);
    procedure actbtnStartExecute(Sender: TObject; Event: TJSEvent);
    procedure DataModuleCreate(Sender: TObject);
  private
    FRemote : TRemoteExecutor;
    procedure DoDoutput(Sender: TObject; aOutput: String);
    procedure DoProcessDone(Sender: TObject; aStatus: TProcessStatus; aExitCode: Integer);
    procedure DoStatusFail(Sender: TObject; aError: String);
  public
  end;

var
  frmIndex: TfrmIndex;

implementation

uses js;

{$R *.lfm}

{ TfrmIndex }


procedure TfrmIndex.DoProcessDone(Sender: TObject; aStatus: TProcessStatus; aExitCode: Integer);

Const
  Exits : Array[TProcessStatus] of string
        = ('Running','Exited','Error');

begin
  Write('Process ',Exits[aStatus]);
  if aStatus=psExited then
    Writeln(' with exit code ',aExitCode)
  else
    Writeln();
end;

procedure TfrmIndex.DoStatusFail(Sender: TObject; aError: String);
begin
  Writeln('Error getting status: ',aError);
end;

procedure TfrmIndex.DoDoutput(Sender: TObject; aOutput: String);
begin
  Writeln(aOutput);
end;

procedure TfrmIndex.actbtnStartExecute(Sender: TObject; Event: TJSEvent);

begin
  FRemote.Execute(actedtA.Value,actedtB.Value);
end;

procedure TfrmIndex.actbtnCancelExecute(Sender: TObject; Event: TJSEvent);
begin
  Writeln('Canceled wait for process.');
  FRemote.Cancel;
end;

procedure TfrmIndex.DataModuleCreate(Sender: TObject);
begin
  FRemote:=TRemoteExecutor.Create(Self);
  FRemote.RPCClient:=rpc;
  FRemote.OnProcessOutput:=@DoDoutput;
  FRemote.OnProcessDone:=@DoProcessDone;
  FRemote.OnStatusFail:=@DoStatusFail;
end;

end.

