unit module.process;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, HTTPDefs, websession, fpHTTP, fpWeb, fpjsonrpc, webjsonrpc, fpjson,
  fpprocesscapture;

type

  { Tprocesscontrol }

  Tprocesscontrol = class(TJSONRPCModule)
    GetStatus: TJSONRPCHandler;
    StartProcess: TJSONRPCHandler;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure GetStatusExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
    procedure StartProcessExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
  private
    Capture: TProcessCapture;
  public

  end;

var
  processcontrol: Tprocesscontrol;

implementation

const
  LongProcess = 'longprocess' {$ifdef windows} + '.exe' {$endif} ;

{$R *.lfm}

{ Tprocesscontrol }

procedure Tprocesscontrol.StartProcessExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);

var
  arr : TJSONArray absolute Params;
  a, b, Exe, PID : string;


begin
  Res:=Nil;
  a:=Arr.Strings[0];
  b:=Arr.Strings[1];
  Exe:=ExtractFilePath(ParamStr(0))+longprocess;
  PID:=Capture.Execute(Exe,[a,b]);
  Res:=TJSONString.Create(PID);
end;

procedure Tprocesscontrol.DataModuleCreate(Sender: TObject);
begin
  Capture:=TProcessCapture.Create(Self);
end;

procedure Tprocesscontrol.DataModuleDestroy(Sender: TObject);
begin
  FreeAndNil(Capture);
end;

procedure Tprocesscontrol.GetStatusExecute(Sender: TObject; const Params: TJSONData; out Res: TJSONData);
var
  arr : TJSONArray absolute Params;
  PID,aOutput : string;
  Offset,Status : Integer;
begin
  Res:=Nil;
  PID:=Arr.Strings[0];
  OffSet:=Arr.Int64s[1];
  if Capture.IsProcessRunning(PID) then
    begin
    Status:=-1
    end
  else
    begin
    Status:=Capture.GetProcessExitStatus(PID);
    end;
  aOutput:=Capture.GetProcessOutput(PID,Offset);
  Res:=TJSONObject.Create(['status',Status,'output',aOutput,'offset',offset]);
end;

initialization
  RegisterHTTPModule('/RPC', Tprocesscontrol);
end.

