program processserver;

{$mode objfpc}{$H+}

uses
  {$ifdef unix}
  baseunix,
  {$endif}
  sysutils,
  classes,
  jsonparser,
  fpwebfile,
  fpmimetypes,
  fphttpapp, module.process;

Type

  { THTTPApplication }

  THTTPApplication = Class(fphttpapp.THTTPApplication)
    constructor Create(aOwner : TComponent); override;
  private
    procedure DoConnect(Sender: TObject; ASocket: Longint; var Allow: Boolean);
  end;


Function GetBaseDir : String;

begin
  Result:=ExtractFilePath(ParamStr(0));
  Result:=Result+'..'+PathDelim+'client2';
  Result:=ExpandFileName(Result);
end;

{ THTTPApplication }

constructor THTTPApplication.Create(aOwner: TComponent);
begin
  inherited Create(aOwner);
  OnAllowConnect:=@DoConnect;
end;

procedure THTTPApplication.DoConnect(Sender: TObject; ASocket: Longint; var Allow: Boolean);
{$IFDEF UNIX}
const
  FD_CLOEXEC = 1;
  {$ENDIF}
begin
{$IFDEF UNIX}
  FpFcntl(aSocket, F_SETFD, FD_CLOEXEC);
{$ENDIF}
  Allow:=True;
end;

Var
  Application:THTTPApplication;

begin
  MimeTypes.LoadKnownTypes;
  TSimpleFileModule.BaseDir:=GetBaseDir;
  TSimpleFileModule.RegisterDefaultRoute;
  TSimpleFileModule.IndexPageName:='index.html';
  Application:=THTTPApplication.Create(Nil);
  Application.Title:='Process server';
  Application.Port:=8060;
  Application.Initialize;
  Application.Run;
  Application.Free;
end.

